C calculate dB(B->Xs l+ l-)/ds  and the FB-asymmetry dA/ds AS
C    in the partonmodell 19.8.96
        PROGRAM MAIN
        IMPLICIT REAL*8 (A-Z)
        COMPLEX G,G0,G1,C9EFF,C9LD
        INTEGER  I,J,NS
        DIMENSION  PB(300),PA(300)
        COMMON/PAR/W
        OPEN(UNIT=9,FILE='parton_BR.dat',STATUS='unknown')
C        OPEN(UNIT=9,FILE='parton_AS.dat',STATUS='unknown')
C NS+1: Number of points, NS should be EVEN if you want 
C to calculate the total width  --------------------------------
        NS=50
        ME=0.000511
C       MMU=0.10568
C MS=s quark mass   MBP=b quark mass, MB=B meson mass ALL in GeV
        MBP=4.8D0
        W=MBP
        MB=5.279D0
        MS=0.2D0
        GF=1.16637D-5
        LT=0.04D0
        SMAX=(W-MS)**2-0.001
C        SMIN=4.0*ME**2
        SMIN=0.5
        DSL=(SMAX-SMIN)/NS
        PI=4.0*ATAN(1.0D0)
         AQED=1/129.0D0
C ------------overallfactor for decaywidth --------
        OVERFAC=GF**2*LT**2*3.0D0*AQED**2/(192.0D0*16.0D0*PI**5)
        C7=-0.3109680295498751
        C10=-4.546069499588136
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C       DO loop for storing  PB(S)
        DO 10, I=1,NS+1
        S=SMIN+DSL*FLOAT(I-1)
C ----------------C9Eff-stuff ------------------------------------------
         C9A=ABS(C9EFF(S))
         C9RE=REAL(C9EFF(S))
C -----------for including the cc resonances use the following definition
C          C9A=ABS(C9EFF(S)+C9LD(S))
C         C9RE=REAL(C9EFF(S)+C9LD(S))
C ________branchingratio and normalized FB-asymmetry _________________
        UPPHASEP= DSQRT(((MBP+MS)**2-S)*( (MBP-MS)**2-S) )
        DBDP0=((MBP**2-MS**2)**2-S**2 )*(C9A**2+C10**2)
     F          + 4.0D0*(MBP**4-MS**2*MBP**2-MS**4
     F          +MS**6/MBP**2-8.0D0*S*MS**2
     F          -S**2*(1.0D0+MS**2/MBP**2) )
     F          *C7**2*MBP**2/S
     F          -8.0D0*(S*(MBP**2+MS**2)-(MBP**2-MS**2)**2)*C9RE*C7
        DBDP1=4.0D0*S*C9RE*C10+8.0D0*(MBP**2+MS**2)*1.0*C10*C7
        DBDP2=-(C9A**2+C10**2)
     F         +4.0D0*(1.0D0+(MS/MBP)**2)*C7**2*MBP**2/S
        DBDSP=1.0D0/MBP**3*
     F  2.0D0*(DBDP0*UPPHASEP+1.0D0/3.0*DBDP2*UPPHASEP**3)
        DADSP=-1.0D0/MB**3*DBDP1*UPPHASEP**2/DBDSP
        PB(I)=0.104*OVERFAC*DBDSP/(4.44E-14)
C        PB(I)=DBDSP
        PA(I)=DADSP
10      CONTINUE
         DO 20 J=1,NS+1
         SS=SMIN+DSL*FLOAT(J-1)
C        WRITE(9,*) SS, PB(J)
         WRITE(9,*) SS, PA(J)
20      CONTINUE
C ------------calculate total width with cernlib-routine ------- 
        TOT=OVERFAC*DSIMPS(PB,SMIN,SMAX,NS)
        WRITE(9,*) TOT,OVERFAC
        CLOSE(unit=9)
        STOP
        END 
C ---------------------------------------------------------   
        DOUBLE PRECISION FUNCTION THETA(X)
        REAL*8 X     
        IF (X .LT. 0) THEN 
        THETA=0.0D0
        ELSE 
        THETA=1.0D0
        ENDIF 
        RETURN
        END
C ----------------------------------------------------------------------   
        COMPLEX FUNCTION G(S) 
        IMPLICIT REAL*8 (A-Z)  
        COMPLEX IMAG
        MU=5.0D0
        MC=1.4D0
        Y=4.0D0*MC**2/S 
        PI=4.0D0*DATAN(1.0D0)
        IMAG=CSQRT((-1.0,0.0))
        G=-8.0D0/9*DLOG(MC/MU)+8.0D0/27.0D0+
     F  4.0D0/9.0D0*Y-2.0D0/9.0D0*(2.0D0+Y)
     F *DSQRT(DABS(1.0D0-Y))*( THETA(1.0D0-Y)*(DLOG(DABS(
     F (1.0D0+DSQRT(DABS(1.0D0-Y) ) )/(1.0D0-DSQRT(DABS(1.0D0-Y)))))
     F  -IMAG*PI )
     F   +THETA(Y-1.0D0)*2.0D0*DATAN(1.0D0/DSQRT(DABS(Y-1.0D0))))
      RETURN
      END
C ----------------------------------------------------------------------      
      COMPLEX FUNCTION G0(S) 
      IMPLICIT REAL*8 (A-Z)
      COMPLEX IMAG
      MU=5.0D0 
      PI=4.0D0*DATAN(1.0D0)
      IMAG=CSQRT((-1.0,0.0))
      G0=8.0D0/27.0D0-4.0D0/9*DLOG(S/MU**2)+4.0D0/9.0D0*IMAG*PI
      RETURN 
      END
C ----------------------------------------------------------------------   
      COMPLEX FUNCTION G1(S)
      IMPLICIT REAL*8 (A-Z)
      COMMON/PAR/W
      COMPLEX IMAG
      MU=5.0D0
      PI=4.0D0*DATAN(1.0D0)
      IMAG=CSQRT((-1.0,0.0))
      Y=4.0D0*W**2/S
      G1=-8.0D0/9*DLOG(W/MU)+8.0D0/27+4.0D0/9*Y-2.0D0/9*(2.0D0+Y)
     F *DSQRT(DABS(1.0D0-Y))*( THETA(1.0D0-Y)*(DLOG(DABS(
     F (1.0D0+DSQRT(DABS(1.0D0-Y) ) )/(1.0D0-DSQRT(DABS(1.0D0-Y)))))
     F  -IMAG*PI )
     F   +THETA(Y-1.0D0)*2.0D0*DATAN(1.0D0/DSQRT(DABS(Y-1.0D0))))
      RETURN
      END
C -----------------------------------------------------------------
      DOUBLE PRECISION FUNCTION LI(X)
C *************************************************************
C REAL SPENCE FUNCTION OBTAINED FROM J. VAN DER BIJ
C *************************************************************
      IMPLICIT REAL*8 (A-Z)
      COMPLEX*16 Y,Z,Z2,SP
      REAL*8 XR,XI,R2
      REAL*8 A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,ZETA2
      DATA A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,ZETA2/
     1 -0.250000000000000D0,
     2 -0.111111111111111D0,
     3 -0.010000000000000D0,
     4 -0.017006802721088D0,
     5 -0.019444444444444D0,
     6 -0.020661157024793D0,
     7 -0.021417300648069D0,
     8 -0.021948866377231D0,
     9 -0.022349233811171D0,
     1 -0.022663689135191D0,
     2  1.644934066848226D0/
      XR=X
      XI=0.0D0
      R2=XR*XR+XI*XI
      IF(R2.GT.1.D0.AND.(XR/R2).GT.0.5D0)THEN
        Y=(X-1.D0)/X
        Z=-LOG(1.D0-Y)
        Z2=Z*Z
        SP=Z*(1.D0+A1*Z*(1.D0+A2*Z*(1.D0+A3*Z2*(1.D0+A4*Z2*
     1 (1.D0+A5*Z2*(1.D0+A6*Z2*(1.D0+A7*Z2*(1.D0+A8*Z2*(1.D0+A9*Z2*
     2 (1.D0+A10*Z2))))))))))
     3 +ZETA2-LOG(X)*LOG(1.D0-X)+0.5D0*LOG(X)**2
        LI=DREAL(SP)
        RETURN
      ELSEIF(R2.GT.1.D0.AND.(XR/R2).LE.0.5D0)THEN
        Y=1.D0/X
        Z=-LOG(1.D0-Y)
        Z2=Z*Z
        SP=-Z*(1.D0+A1*Z*(1.D0+A2*Z*(1.D0+A3*Z2*(1.D0+A4*Z2*
     1 (1.D0+A5*Z2*(1.D0+A6*Z2*(1.D0+A7*Z2*(1.D0+A8*Z2*(1.D0+A9*Z2*
     2 (1.D0+A10*Z2))))))))))
     3 -ZETA2-0.5D0*LOG(-X)**2
        LI=DREAL(SP)
        RETURN
      ELSEIF(R2.EQ.1.D0.AND.XI.EQ.0.D0)THEN
        SP=ZETA2
        LI=DREAL(SP)
        RETURN
      ELSEIF(R2.LE.1.D0.AND.XR.GT.0.5D0)THEN
        Y=1.D0-X
        Z=-LOG(1.D0-Y)
        Z2=Z*Z
        SP=-Z*(1.D0+A1*Z*(1.D0+A2*Z*(1.D0+A3*Z2*(1.D0+A4*Z2*
     1 (1.D0+A5*Z2*(1.D0+A6*Z2*(1.D0+A7*Z2*(1.D0+A8*Z2*(1.D0+A9*Z2*
     2 (1.D0+A10*Z2))))))))))
     3 +ZETA2-LOG(X)*LOG(1.D0-X)
       LI=DREAL(SP)
       RETURN
      ELSEIF(R2.LE.1.D0.AND.XR.LE.0.5D0)THEN
        Y=X
        Z=-LOG(1.D0-Y)
        Z2=Z*Z
        SP=Z*(1.D0+A1*Z*(1.D0+A2*Z*(1.D0+A3*Z2*(1.D0+A4*Z2*
     1 (1.D0+A5*Z2*(1.D0+A6*Z2*(1.D0+A7*Z2*(1.D0+A8*Z2*(1.D0+A9*Z2*
     2 (1.D0+A10*Z2))))))))))
        LI=DREAL(SP)
        RETURN
      ENDIF
      END
C ----------------------------------------------------------------------   
      DOUBLE PRECISION FUNCTION OMEGA(S)
      IMPLICIT REAL*8 (A-Z)
      COMMON/PAR/W
      PI=4.0D0*DATAN(1.0D0)
      SH=S/W**2
      OMEGA=-2.0D0/9.0D0*PI**2-4.0D0/3.0D0*LI(SH) 
     F  -2.0D0/3.0D0*DLOG(SH)*DLOG(1.0D0-SH)
     F -(5.0D0+4.0D0*SH)/
     F (3.0D0*(1.0D0+2.0D0*SH))*DLOG(1.0D0-SH)-2.0D0/3*SH*(1.0D0+SH)
     F *(1.0D0-2.0D0*SH)/((1.0D0-SH)**2*(1.0D0+2.0D0*SH))
     F *DLOG(SH)+(5.0D0+9.0D0*SH-6.0D0*SH**2)/(6.0D0*(1.0D0-SH)
     F *(1.0D0+2.0D0*SH))
      RETURN
      END
C -------------------------------------------------------------------------
      COMPLEX FUNCTION C9EFF(S)
      IMPLICIT REAL*8 (A-Z)
      COMPLEX G,G1,G0
      PI=4.0D0*DATAN(1.0D0)
      C1=-0.24037831D0
      C2=1.103120985D0
      C3=0.010687797D0
      C4=-0.02487252D0
      C5=0.007197235D0
      C6=-0.03022652D0
      C9NDR=4.153010D0
      ALPHASMU=0.210098D0
      C9EFF=C9NDR*(1.0D0+ALPHASMU/PI*OMEGA(S))+
     F G(S)*(3.0D0*C1+C2+3.0D0*C3+C4+3.0D0*C5+C6)
     F -1.0D0/2.0D0*G0(S)*(C3+3.0D0*C4)-1.0D0/2.0D0*G1(S)
     F *(4.0D0*C3+4.0D0*C4+3.0D0*C5+C6)
     F +2.0D0/9.0D0*(3.0D0*C3+C4+3.0D0*C5+C6)
      RETURN
      END 
C -----------------------------------------------------------------------
      COMPLEX FUNCTION C9LD(S)
      IMPLICIT REAL*8 (A-Z)
      COMPLEX IMAG,DELTA
      INTEGER I
      DIMENSION MCC(6), BR(6), GTOT(6)
      C1=-0.24037831D0
      C2=1.103120985D0
      C3=0.010687797D0
      C4=-0.02487252D0
      C5=0.007197235D0
      C6=-0.03022652D0
      C0=3.0D0*C1+C2+3.0D0*C3+C4+3.0D0*C5+C6
C  kappa from ligeti & wise hep ph9512225
      KAPPA=2.3D0
      PI=4.0D0*DATAN(1.0D0)
      IMAG=CSQRT((-1.0,0.0))
      AQED=1.0D0/129.0D0
      DELTA=0.0D0
C ----masses,branchingratios and total widths of cc-resonances -------------
      MCC(1)=3.097D0
      MCC(2)=3.686D0
      MCC(3)=3.770D0
      MCC(4)=4.040D0
      MCC(5)=4.159D0
      MCC(6)=4.415D0
      BR(1)=6.0D-2
      BR(2)=8.3D-3
      BR(3)=1.1D-5
      BR(4)=1.4D-5
      BR(5)=1.0D-5
      BR(6)=1.1D-5
      GTOT(1)=0.088D-3
      GTOT(2)=0.277D-3
      GTOT(3)=23.6D-3
      GTOT(4)=52.0D-3
      GTOT(5)=78.0D-3
      GTOT(6)=43.0D-3
      DO 2002 I=1,6
      DELTA=DELTA+BR(I)*MCC(I)*GTOT(I)/(MCC(I)**2-S-IMAG*MCC(I)*GTOT(I))
 2002 CONTINUE
      C9LD=C0*KAPPA*3.0D0*PI/AQED**2*DELTA
      RETURN
      END
C ----------------------------------------------------------------------











































